; plates - theme for sawfish
; Copyright (C) 2001  Yuichi Kobayashi <kobayasy@mbox.kyoto-inet.or.jp>

(let* (
  (font (get-font "-*-lucida-medium-r-normal-*-10-*-*-*-*-*-*-*"))
  (font-colors (list "grey" "white"))
  (title-l-images (list
    (make-image "title-l-inactive.png")
    (make-image "title-l-active.png") ))
  (title-images (list
    (make-image "title-inactive.png")
    (make-image "title-active.png") ))
  (title-r-images (list
    (make-image "title-r-inactive.png")
    (make-image "title-r-active.png") ))
  (close-images (list
    (make-image "close-inactive.png")
    (make-image "close-oncursor.png")
    nil
    (make-image "close-clicked.png") ))
  (maximize-images (list
    (make-image "maximize-inactive.png")
    (make-image "maximize-oncursor.png")
    nil
    (make-image "maximize-clicked.png") ))
  (iconify-images (list
    (make-image "iconify-inactive.png")
    (make-image "iconify-oncursor.png")
    nil
    (make-image "iconify-clicked.png") ))
  (menu-images (list
    (make-image "menu-inactive.png")
    (make-image "menu-oncursor.png")
    nil
    (make-image "menu-clicked.png") ))
  (mover-images (list
    (make-image "mover-inactive.png")
    (make-image "mover-oncursor.png")
    nil
    (make-image "mover-clicked.png") ))
  (resizer-bl-images (list
    (make-image "resizer-bl-inactive.png")
    (make-image "resizer-bl-oncursor.png")
    nil
    (make-image "resizer-bl-clicked.png") ))
  (resizer-br-images (list
    (make-image "resizer-br-inactive.png")
    (make-image "resizer-br-oncursor.png")
    nil
    (make-image "resizer-br-clicked.png") ))
  (border-tl-images (list
    (make-image "border-tl-inactive.png")
    (make-image "border-tl-active.png") ))
  (border-tr-images (list
    (make-image "border-tr-inactive.png")
    (make-image "border-tr-active.png") ))
  (border-bl-images (list
    (make-image "border-bl-inactive.png")
    (make-image "border-bl-active.png") ))
  (border-br-images (list
    (make-image "border-br-inactive.png")
    (make-image "border-br-active.png") ))
  (border-t-images (list
    (make-image "border-t-inactive.png")
    (make-image "border-t-active.png") ))
  (border-b-images (list
    (make-image "border-b-inactive.png")
    (make-image "border-b-active.png") ))
  (border-l-images (list
    (make-image "border-l-inactive.png")
    (make-image "border-l-active.png") ))
  (border-r-images (list
    (make-image "border-r-inactive.png")
    (make-image "border-r-active.png") ))
  (title-width (lambda (w)
    (max (min (text-width (window-name w) font)
              (- (car (window-dimensions w)) 67) )
         0 ) ))
  (title-shaped-width (lambda (w)
    (max (min (text-width (window-name w) font)
              (- (car (window-dimensions w)) 16) )
         0 ) ))
  (default-frame `(
    ((background . ,border-tl-images)
     (top-edge . -2) (left-edge . -2) )
    ((background . ,border-tr-images)
     (top-edge . -2) (right-edge . -2) )
    ((background . ,border-bl-images)
     (bottom-edge . -2) (left-edge . -2) )
    ((background . ,border-br-images)
     (bottom-edge . -2) (right-edge . -2) )
    ((background . ,border-t-images)
     (top-edge . -2) (left-edge . 0) (right-edge . 0) )
    ((background . ,border-b-images)
     (bottom-edge . -2) (left-edge . 0) (right-edge . 0) )
    ((background . ,border-l-images)
     (left-edge . -2) (top-edge . 0) (bottom-edge . 0) )
    ((background . ,border-r-images)
     (right-edge . -2) (top-edge . 0) (bottom-edge . 0) )
    ((background . ,title-l-images)
     (top-edge . -12) (left-edge . 0)
     (class . title) )
    ((background . ,title-images)
     (top-edge . -12) (left-edge . 8) (width . ,(lambda (w) (title-width w)))
     (foreground . ,font-colors) (font . ,font) (text . ,window-name)
     (x-justify . center) (y-justify . center)
     (class . title) )
    ((background . ,title-r-images)
     (top-edge . -12) (left-edge . ,(lambda (w) (+ 8 (title-width w))))
     (class . title) )
    ((background . ,close-images)
     (top-edge . -12) (right-edge . 0)
     (class . close-button) )
    ((background . ,maximize-images)
     (top-edge . -12) (right-edge . 17)
     (class . maximize-button) )
    ((background . ,iconify-images)
     (top-edge . -12) (right-edge . 34)
     (class . iconify-button) )
    ((background . ,menu-images)
     (top-edge . 0) (left-edge . -12)
     (class . menu-button) )
    ((background . ,mover-images)
     (top-edge . 0) (right-edge . -12)
     (cursor . fleur)
     (class . title) )
    ((background . ,resizer-bl-images)
     (bottom-edge . -8) (left-edge . -8)
     (class . bottom-left-corner) )
    ((background . ,resizer-br-images)
     (bottom-edge . -8) (right-edge . -8)
     (class . bottom-right-corner) )
  ))
  (transient-frame `(
    ((background . ,border-tl-images)
     (top-edge . -2) (left-edge . -2) )
    ((background . ,border-tr-images)
     (top-edge . -2) (right-edge . -2) )
    ((background . ,border-bl-images)
     (bottom-edge . -2) (left-edge . -2) )
    ((background . ,border-br-images)
     (bottom-edge . -2) (right-edge . -2) )
    ((background . ,border-t-images)
     (top-edge . -2) (left-edge . 0) (right-edge . 0) )
    ((background . ,border-b-images)
     (bottom-edge . -2) (left-edge . 0) (right-edge . 0) )
    ((background . ,border-l-images)
     (left-edge . -2) (top-edge . 0) (bottom-edge . 0) )
    ((background . ,border-r-images)
     (right-edge . -2) (top-edge . 0) (bottom-edge . 0) )
    ((background . ,title-l-images)
     (top-edge . -12) (left-edge . 0)
     (class . title) )
    ((background . ,title-images)
     (top-edge . -12) (left-edge . 8) (width . ,(lambda (w) (title-shaped-width w)))
     (foreground . ,font-colors) (font . ,font) (text . ,window-name)
     (x-justify . center) (y-justify . center)
     (class . title) )
    ((background . ,title-r-images)
     (top-edge . -12) (left-edge . ,(lambda (w) (+ 8 (title-shaped-width w))))
     (class . title) )
  ))
  (shaped-frame `(
    ((background . ,title-l-images)
     (top-edge . -12) (left-edge . 0)
     (class . title) )
    ((background . ,title-images)
     (top-edge . -12) (left-edge . 8) (width . ,(lambda (w) (title-shaped-width w)))
     (foreground . ,font-colors) (font . ,font) (text . ,window-name)
     (x-justify . center) (y-justify . center)
     (class . title) )
    ((background . ,title-r-images)
     (top-edge . -12) (left-edge . ,(lambda (w) (+ 8 (title-shaped-width w))))
     (class . title) )
  ))
  )
  (add-frame-style 'plates (lambda (w type)
    (case type ((default) default-frame)
               ((transient) transient-frame)
               ((shaped) shaped-frame)
               ((shaped-transient) shaped-frame) ) ))
  (call-after-property-changed 'WM_NAME (lambda ()
    (rebuild-frames-with-style 'plates) ))
)
